'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ResizeSensor = require('./vendor/ResizeSensor/ResizeSensor.js');

var _ResizeSensor2 = _interopRequireDefault(_ResizeSensor);

var _ReactComponentWithPureRenderMixin = require('react/lib/ReactComponentWithPureRenderMixin');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var SizeReporter = function (_React$Component) {
  _inherits(SizeReporter, _React$Component);

  function SizeReporter(props) {
    _classCallCheck(this, SizeReporter);

    var _this = _possibleConstructorReturn(this, (SizeReporter.__proto__ || Object.getPrototypeOf(SizeReporter)).call(this, props));

    _this.shouldComponentUpdate = _ReactComponentWithPureRenderMixin.shouldComponentUpdate;

    _this.attachListener = function () {
      if (_this.node) {
        _this.ResizeSensor = new _ResizeSensor2.default(_this.node, function () {
          return _this.props.onSizeChange({ height: _this.node.offsetHeight, width: _this.node.offsetWidth });
        });
      }
    };

    _this.reattachResizeListener = function () {
      _this.ResizeSensor.detach();
      _this.attachListener();
    };

    _this.ResizeSensor = null;
    _this.offsetHeight = null;
    _this.offsetWidth = null;
    return _this;
  }

  _createClass(SizeReporter, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.node = _reactDom2.default.findDOMNode(this);
      this.attachListener();
      this.props.onSizeChange({ height: this.node.offsetHeight, width: this.node.offsetWidth });
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      if (this.ResizeSensor) {
        this.ResizeSensor.detach();
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this.node && (this.node.offsetHeight !== this.offsetHeight || this.node.offsetWidth !== this.offsetWidth)) {
        this.props.onSizeChange({ height: this.node.offsetHeight, width: this.node.offsetWidth });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var onSizeChange = _props.onSizeChange;

      var props = _objectWithoutProperties(_props, ['children', 'onSizeChange']);

      if (this.node) {
        this.offsetHeight = this.node.offsetHeight;
        this.offsetWidth = this.node.offsetWidth;
      }

      return _react2.default.createElement(
        'div',
        props,
        children || null
      );
    }
  }]);

  return SizeReporter;
}(_react2.default.Component);

SizeReporter.propTypes = {
  children: _propTypes2.default.node.isRequired,
  onSizeChange: _propTypes2.default.func.isRequired
};
exports.default = SizeReporter;
//# sourceMappingURL=ReactSizeReporter.js.map